import std.stdio;
import std.stream;
import std.string;
import std.utf;
import std.math;

//
// PSG風音源 レンダラ
//

class Sound {
  double[][] FreqTable ;

  struct CMDstruct{
    string inst ;
    int    param ;
  } ;
  CMDstruct[][] cmdbuf ;
  int[string]   cmdptr ;
  int[string]   trackID ;
  int           tracknum ;

    
  this(){
    FreqTable.length=9 ;
    int cnt=0 ;
    for( int j=0 ; j<FreqTable.length ; j++ ){//オクターブループ
      FreqTable[j].length=12 ;
      for( int i=0 ; i<12 ; i++ ){ //音階ループ
	FreqTable[j][i] = 55.0 * pow(110.0/55.0 , (-9.0+cnt)/12.0) ;
	cnt++ ;
	//	writef("O%d S%d %f\n",j,i,FreqTable[j][i]) ;
      }
    }
  }

  
  int readMML(string fname){
    auto        infile = new BufferedFile(fname) ;
    string      line ;
    int         i, time ;
    char[]      buf ;
    int         ptr, len ;

    tracknum=0 ;
    trackID =null ;
    cmdbuf  =null ;
    cmdptr  =null ;
    
    cmdbuf.length  = 8 ;
    
    string cur_track ;
    int   macroExpand_stack=0 ;
    int[] macroExpand_start_cmdptr ; macroExpand_start_cmdptr.length=64 ;
    int[] macroExpand_end_cmdptr   ; macroExpand_end_cmdptr.length  =64 ;
      
    while( infile.eof()==false ){
      line=cast(string)infile.readLine() ;
      if( line is null   ) line="" ;
      if( line.length==0 ) continue ;
      
      buf = line.dup ;
      
      macroExpand_stack=0 ;
      
      int readBody=0 ;
      for( i=0 ; i<buf.length ; i++ ){
	
	while( buf[i]==' ' || buf[i]=='\t' ) {i++;if(i>=buf.length) break;} //スペースを飛ばす
	if( buf[i]==';' ) break ;
	
	if( readBody==0 ){
	  ptr=i ; len=0 ;
	  while( buf[i]!=' ' && buf[i]!='\t' ) {len++;i++;if(i>=buf.length) break;}
	  cur_track = buf[ptr..(ptr+len)].idup ;
	  if( (cur_track in trackID)==null ){
	    cmdptr[ cur_track]=0 ;
	    trackID[cur_track]=tracknum++ ;
	    cmdbuf[trackID[cur_track]].length=1024 ;
	    if( tracknum==cmdbuf.length ){
	      cmdbuf.length = cmdbuf.length * 2 ;
	    }
	  }
	  //	  writef("track is %s\n",buf[ptr..(ptr+len)].idup) ;
	  
	  while( buf[i]==' ' || buf[i]=='\t' ) {i++;if(i>=buf.length) break;} //スペースを飛ばす
	  i-- ;
	  readBody=1 ;
	}else{
	  
	  //-------ABCDEFGR 音階/休符
	  if( (buf[i]>='a' && buf[i]<='g') || (buf[i]>='A' && buf[i]<='G') || buf[i]=='r' || buf[i]=='R' ){
	    string cmd=toUpper(buf[i..i+1].idup) ;
	    int    param=0 ;
	    
	    i++;if(i>=buf.length){
	      addCMD(cur_track, cmd, param) ;
	      break;
	    }else{
	      if( buf[i]=='-' || buf[i]=='+' ){ // フラット/シャープ
		cmd=cmd ~ buf[i..i+1].idup ;
		i++ ; if(i>=buf.length) break;
	      }
	      if( i<buf.length ){
		if( buf[i]>='0' && buf[i]<='9' ){ //音長
		  ptr=i;len=0;
		  while( buf[i]>='0' && buf[i]<='9' ){len++;i++;if(i>=buf.length) break;}
		  param=std.conv.to!(int)(buf[ptr..(ptr+len)].idup) << 8;
		}
	      }
	      if( i<buf.length ){
		if( buf[i]=='.' ){ //付点
		  ptr=i;len=0;
		  while( buf[i]=='.' ){len++;i++;if(i>=buf.length) break;}
		  param = param | (len & 0xff) ;
		}
	      }
	      i-- ;
	      
	      addCMD(cur_track, cmd, param) ;
	      continue ;
	    }
	  }
	  
	  //-------TOVQL)( テンポ/オクターブ/ベロシティ/ゲートタイム/音長/ベロシティ上げ/下げ
	  if( buf[i]=='t' || buf[i]=='T' || buf[i]=='o' || buf[i]=='O' || buf[i]=='v' || buf[i]=='V' ||
	      buf[i]=='q' || buf[i]=='Q' || buf[i]=='l' || buf[i]=='L' ||
	      buf[i]==')' || buf[i]=='(' ){
	    string cmd=toUpper(buf[i..i+1].idup) ;
	    int    param=-1 ;
	    
	    i++;if(i>=buf.length){
	      addCMD(cur_track, cmd, param) ;
	      break;
	    }else{
	      if( cmp(cmd,")")==0 || cmp(cmd,"(")==0 ){
		param=0 ;
		if( buf[i]>='0' && buf[i]<='9' ){
		  ptr=i;len=0;
		  while( buf[i]>='0' && buf[i]<='9' ){len++;i++;if(i>=buf.length) break;}
		  param=std.conv.to!(int)(buf[ptr..(ptr+len)].idup) ;
		}
		addCMD(cur_track, cmd, param) ;
		i-- ;
	      }else{
		if( buf[i]>='0' && buf[i]<='9' ){
		  ptr=i;len=0;
		  while( buf[i]>='0' && buf[i]<='9' ){len++;i++;if(i>=buf.length) break;}
		  param=std.conv.to!(int)(buf[ptr..(ptr+len)].idup) ;
		  addCMD(cur_track, toUpper(cmd), param) ;
		}
		i-- ;
	      }
	    }
	    continue ;
	  }
	  
	  //------- >< オクターブ上げ/下げ
	  if( buf[i]=='>' || buf[i]=='<' ){
	    string cmd=toUpper(buf[i..i+1].idup) ;
	    int    param=0 ;
	    addCMD(cur_track, cmd, param) ;
	    continue ;
	  }
	  
	  //------- []n マクロ展開
	  if( buf[i]=='[' ){
	    macroExpand_start_cmdptr[macroExpand_stack]=cmdptr[cur_track] ;
	    macroExpand_stack++ ;
	    if( macroExpand_stack==macroExpand_start_cmdptr.length ){
	      macroExpand_start_cmdptr.length = macroExpand_start_cmdptr.length * 2 ;
	      macroExpand_end_cmdptr.length   = macroExpand_end_cmdptr.length   * 2 ;
	    }
	    continue ;
	  }
	  if( buf[i]==']' ){
	    int param=0 ;
	    i++;if(i>=buf.length){
	    }else{
	      if( buf[i]>='0' && buf[i]<='9' ){
		ptr=i;len=0;
		while( buf[i]>='0' && buf[i]<='9' ){len++;i++;if(i>=buf.length) break;}
		param=std.conv.to!(int)(buf[ptr..(ptr+len)].idup) ;
	      }
	      i-- ;
	    }
	    macroExpand_stack-- ;
	    macroExpand_end_cmdptr[macroExpand_stack]=cmdptr[cur_track] ;
	    param-- ;
	    for( int k=0 ; k<param ; k++ ){
	      for( int j=macroExpand_start_cmdptr[macroExpand_stack] ; j<macroExpand_end_cmdptr[macroExpand_stack] ; j++ ){
		addCMD(cur_track, cmdbuf[trackID[cur_track]][j].inst, cmdbuf[trackID[cur_track]][j].param)  ;
	      }
	    }
	    continue ;
	  }
	  
	}
      }
    }
    infile.close() ;

    cmdbuf.length = tracknum ;
    foreach ( keyname ; trackID.keys ){
      cmdbuf[trackID[keyname]].length  =cmdptr[keyname] ;
      //      writef("cmdleng=%d\n",cmdbuf[trackID[keyname]].length) ;
      //      for( i=0 ; i<cmdptr[keyname] ; i++ ){
      //	writef("track=%s cmd=%-4s param=%08x\n",keyname,cmdbuf[trackID[keyname]][i].inst, cmdbuf[trackID[keyname]][i].param) ;
      //      }
    }
    seektopCMD() ;
    
    return(0) ;
  }

  
  private int addCMD( string cur_track, string cmd, int param ){
    cmdbuf[trackID[cur_track]][cmdptr[cur_track]].inst  = toUpper(cmd) ;
    cmdbuf[trackID[cur_track]][cmdptr[cur_track]].param = param ;
    cmdptr[cur_track]++ ;
    if( cmdptr[cur_track]==cmdbuf[trackID[cur_track]].length ){
      cmdbuf[trackID[cur_track]].length = cmdbuf[trackID[cur_track]].length*2 ;
    }
    return(0) ;
  }

  private CMDstruct getCMD( string cur_track ){
    CMDstruct retstr ;
    retstr.inst ="" ;
    retstr.param=-1 ;
    if( cmdptr[cur_track]<cmdbuf[trackID[cur_track]].length ){
      retstr=cmdbuf[trackID[cur_track]][cmdptr[cur_track]] ;
      cmdptr[cur_track]++ ;
    }
    return(retstr) ;
  }

  private int seektopCMD(){
    foreach ( keyname ; trackID.keys ){
      cmdptr[keyname]=0 ;
    }
    return(0) ;
  }
  
  private int seektopCMD( string cur_track ){
    if( (cur_track in trackID) != null ){
      cmdptr[cur_track]=0 ;
      return(0) ;
    }
    return(-1) ;
  }
  
  int rendWave(char[] OutputWave, int sample_rate ){
    int i ;

    for( i=0 ; i<OutputWave.length ; i++ ) {
      OutputWave[i]  = 0 ;
    }
    CMDstruct   cmd    ;
    int[string] cmdTbl ;

    cmdTbl["C" ] = 0x00000000 ; cmdTbl["B+"] = 0x00000000 ;
    cmdTbl["C+"] = 0x00000001 ; cmdTbl["D-"] = 0x00000001 ;
    cmdTbl["D" ] = 0x00000002 ;
    cmdTbl["D+"] = 0x00000003 ; cmdTbl["E-"] = 0x00000003 ;
    cmdTbl["E" ] = 0x00000004 ; cmdTbl["F-"] = 0x00000004 ;
    cmdTbl["F" ] = 0x00000005 ; cmdTbl["E+"] = 0x00000005 ;
    cmdTbl["F+"] = 0x00000006 ; cmdTbl["G-"] = 0x00000006 ;
    cmdTbl["G" ] = 0x00000007 ;
    cmdTbl["G+"] = 0x00000008 ; cmdTbl["A-"] = 0x00000008 ;
    cmdTbl["A" ] = 0x00000009 ;
    cmdTbl["A+"] = 0x0000000A ; cmdTbl["B-"] = 0x0000000A ;
    cmdTbl["B" ] = 0x0000000B ;
    cmdTbl["R" ] = 0x00000010 ;

    cmdTbl["T" ] = 0x80000000 ;
    cmdTbl["O" ] = 0x80000001 ;
    cmdTbl["V" ] = 0x80000002 ;
    cmdTbl["Q" ] = 0x80000003 ;
    cmdTbl["<" ] = 0x80000004 ;
    cmdTbl[">" ] = 0x80000005 ;
    cmdTbl["(" ] = 0x80000006 ;
    cmdTbl[")" ] = 0x80000007 ;
    cmdTbl["L" ] = 0x80000008 ;
    
    foreach ( cur_track ; trackID.keys ){
      int mlen_ptr  =     0 ;
      int mlenQ_ptr =     0 ;
      int mlen      =     4 ;
      int octave    =     3 ;
      int V         =    50 ;
      int tempo     = 32000 ;
      int curQ      =     6 ;
      int slp_state =     1 ;
      int scale ;
      for( i=0 ; i<OutputWave.length ; i++ ) {
	if( mlenQ_ptr==i ){
	  slp_state=1 ;
	}
	if( mlen_ptr==i ){
	  slp_state=1 ;
	  while(-1){
	    cmd = getCMD( cur_track ) ;
	    if( (cmd.inst in cmdTbl)!=null ){
	      if( (cmdTbl[cmd.inst] & 0x80000000)==0 ){
		if( cmdTbl[cmd.inst]==0x10 ){
		}else{
		  scale = cmdTbl[cmd.inst] ;
		  slp_state=0 ;
		}
		int len ;
		if( (cmd.param>>8) > 0 ){
		  len = (cmd.param >> 8) ;
		}else{
		  len = mlen ;
		}
		int d = len ;
		for( int j=0 ; j<(cmd.param & 0xff) ; j++ ){
		  d   += d ;
		  len += d ;
		}
		mlenQ_ptr = mlen_ptr + (tempo/len)*curQ/8 ;
		mlen_ptr  = mlen_ptr +  tempo/len ;
		break; 
	      }else{
		switch( cmdTbl[cmd.inst] ){
		case 0x80000000 :
		  tempo   = 35000 * 100 /cmd.param ;
		  break ;
		case 0x80000001 :
		  octave = cmd.param ;
		  break ;
		case 0x80000002 :
		  V = cmd.param ;
		  break ;
		case 0x80000003 :
		  curQ = cmd.param ;
		  break ;
		case 0x80000004 :
		  octave-- ;
		  break ;
		case 0x80000005 :
		  octave++ ;
		  break ;
		case 0x80000008 :
		  mlen=cmd.param ;
		  break ;
		default : break ;
		}
	      }
	    }else{
	      seektopCMD( cur_track ) ;
	      i-- ;
	      break;
	    }
	  }
	}
	if( slp_state==1 ){
	}else{
	  int ramda ;
	  ramda = cast(int)(sample_rate /FreqTable[octave][scale]) ;
	  OutputWave[i]  += (i % ramda)<(ramda/3) ? V : 0 ;
	}
      }
    }

    return(0) ;
  }

}  


//      
//     -+-   +---------+         +
//      |    |         |         |
//      |    |         |         |
//      V    |         |         |
//      |    |         |         |
//     _|_   |         |_________|
//         
//           |-------周期--------|
//           |------------------------時間-----------------|
//
//   入力 : 音階(scale,octave)、音長(leng,Q)
//   パラメータ : テンポ(tempo)、サンプリングレート(sample_rate)
//
//  周期 <= FreqTable[octave][scale]
//  時間 <= (1/tempo * leng)
//
//  O0-A を 55Hz としたとき、 O0-B は
//    55 * ((110/55)**(1/12))**1
//    (110/55)**(1/12)=1.05946309435929526456.... ←12分率の係数
//  
//
//  O0  C  24  32.70319  (* 1.0594**-9)
//      C# 25  34.64782  (* 1.0594**-8)
//      D  26  36.70809  (* 1.0594**-7)
//      D# 27  38.89087  (* 1.0594**-6)
//      E  28  41.20344  (* 1.0594**-5)
//      F  29  43.65352  (* 1.0594**-4)
//      F# 30  46.24930  (* 1.0594**-3)
//      G  31  48.99942  (* 1.0594**-2)
//      G# 32  51.91308  (* 1.0594**-1)
//      A  33  55.00000  (* 1.0594**0 )
//      A# 34  58.27047  (* 1.0594**1 )
//      B  35  61.73541  (* 1.0594**2 )
//  O1  C  36  65.40639  (* 1.0594**3 )
//      C# 37  65.40639  (* 1.0594**4 )
//      D  38  69.29565  (* 1.0594**5 )
//      D# 39  77.78174  (* 1.0594**6 )
//      E  40  82.40688  (* 1.0594**7 )
//      F  41  87.30705  (* 1.0594**8 )
//      F# 42  92.49860  (* 1.0594**9 )
//      G  43  97.99885  (* 1.0594**10)
//      G# 44 103.8261   (* 1.0594**11)
//      A  45 110.0000   (* 1.0594**12)
//
